org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class AddVertexStartStep

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<Vertex,Vertex>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.map.AddVertexStartStep

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<Vertex>>, Parameterizing, Step<Vertex,Vertex>, Mutating<Event.VertexAddedEvent>, Scoping, TraversalParent

      public final class AddVertexStartStep
      extends AbstractStep<Vertex,Vertex>
      implements Mutating<Event.VertexAddedEvent>, TraversalParent, Parameterizing, Scoping

  Author:
    Marko A. Rodriguez (http://markorodriguez.com), Stephen Mallette (http://stephen.genoprime.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `Scoping.Variable`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AddVertexStartStep(Traversal.Admin traversal, String label)`
    `AddVertexStartStep(Traversal.Admin traversal, Traversal<?,String> vertexLabelTraversal)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addPropertyMutations(Object... keyValues)`
    `AddVertexStartStep` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `<S,E> List<Traversal.Admin<S,E>>` | `getLocalChildren()`
    `CallbackRegistry<Event.VertexAddedEvent>` | `getMutatingCallbackRegistry()` Gets the callback registry for events that the step raises.
    `Parameters` | `getParameters()` Gets the parameters on the step.
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `Set<String>` | `getScopeKeys()` Get the labels that this scoping step will access during the traversal
    `int` | `hashCode()`
    `protected Traverser.Admin<Vertex>` | `processNextStart()`
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getTraversal, hasNext, next, removeLabel, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `getNullableScopeValue, getScopeValue`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### AddVertexStartStep

          public AddVertexStartStep(Traversal.Admin traversal,
                                    String label)

    - #### AddVertexStartStep

          public AddVertexStartStep(Traversal.Admin traversal,
                                    Traversal<?,String> vertexLabelTraversal)

  - ### Method Detail

    - #### getParameters

          public Parameters getParameters()

      Description copied from interface: `Parameterizing`
      Gets the parameters on the step.
      Specified by:
        `getParameters` in interface `Parameterizing`

    - #### getScopeKeys

          public Set<String> getScopeKeys()

      Description copied from interface: `Scoping`
      Get the labels that this scoping step will access during the traversal
      Specified by:
        `getScopeKeys` in interface `Scoping`
      Returns:
        the accessed labels of the scoping step

    - #### getLocalChildren

          public <S,E> List<Traversal.Admin<S,E>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### addPropertyMutations

          public void addPropertyMutations(Object... keyValues)

      Specified by:
        `addPropertyMutations` in interface `Mutating<Event.VertexAddedEvent>`

    - #### processNextStart

          protected Traverser.Admin<Vertex> processNextStart()

      Specified by:
        `processNextStart` in class `AbstractStep<Vertex,Vertex>`

    - #### getMutatingCallbackRegistry

          public CallbackRegistry<Event.VertexAddedEvent> getMutatingCallbackRegistry()

      Description copied from interface: `Mutating`
      Gets the callback registry for events that the step raises.
      Specified by:
        `getMutatingCallbackRegistry` in interface `Mutating<Event.VertexAddedEvent>`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<Vertex,Vertex>`
      Returns:
        the set of requirements

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<Vertex,Vertex>`

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<Vertex,Vertex>`
      Overrides:
        `reset` in class `AbstractStep<Vertex,Vertex>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<Vertex,Vertex>`

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<Vertex,Vertex>`
      Overrides:
        `setTraversal` in class `AbstractStep<Vertex,Vertex>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### clone

          public AddVertexStartStep clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<Vertex,Vertex>`
      Overrides:
        `clone` in class `AbstractStep<Vertex,Vertex>`
      Returns:
        The cloned step

Copyright © 2013–2020 Apache Software Foundation. All rights reserved.